NB. Names for primitives
NB.
NB. This script assigns names used in the Vocabulary and Dictionary.
NB. All names begin with Capitals.  Multiple word names
NB. have all words capitalised and are joined without blanks or other characters.
NB. Words are not abbreviated unless it is to follow either the
NB. Vocabulary or Dictionary head words.
NB. Names which are duplicated in either source have the second usage in
NB. Uppercase

cocurrent 'z'

SelfClassify=: Equal=: =

Box=: LessThan=: <
Floor=: LesserOf=: Min=: <.
Decrement=: LessThanOrEqual=: LessOrEqual=: <:

Open=: LargerThan=: >
Ceiling=: LargerOf=: Max=: >.
Increment=: LargerOrEqual=: >:

Infinity=: _
Indeterminate=: _.
INFINITY=: _:

Conjugate=: Plus=: +
RealImaginary=: GCD=: Or=: +.
Double=: NotOr=: +:

Signum=: Times=: *
LengthAngle=: LCM=: And=: *.
Square=: NotAnd=: *:

Negate=: Minus=: -
Not=: Less=: -.
Halve=: Match=: -:

Reciprocal=: DividedBy=: Divide=: %
MatrixInverse=: MatrixDivide=: %.
SquareRoot=: Root=: %:

Exponential=: Power=: ^
NaturalLog=: Logarithm=: ^.
POWER=: ^:

ShapeOf=: Shape=: $
Sparse=: $.
SelfReference=: $:

Evoke=: Reflexive=: Reflex=: Passive=: ~
Nub=: ~.
NubSieve=: NotEqual=: ~:

Magnitude=: Residue=: |
Reverse=: Rotate=: |.
Transpose=: |:

Determinant=: DotProduct=: .
Even=: ..
Odd=: .:

ExplicitDefinition=:  MonadDyad=: :
NB. the following line retains a present shorter form
Explicit=: :
Obverse=: :.
Adverse=: ::

Ravel=: Append=: ,
RavelItems=: Stitch=: ,.
Itemize=: Laminate=: ,:

Raze=: Link=: ;
Cut=: ;.
WordFormation=: Words =: SequentialMachine =:  ;:

Tally=: Copy=: #
BaseTwo=: Base2=: Base=: #.
AntibaseTwo=: Antibase2=: Antibase=: #:

Factorial=: OutOf=: Combinations=: !
Fit=: Customize=: !.
Foreign=: !:

Insert=: Table=: /
Oblique=: Key=: /.
GradeUp=: SortUp=: Sort =: /:

Prefix=: Infix=: \
Suffix=: Outfix=: \.
GradeDown=: SortDown=: SORT=: \:

Same=: Left=: [
Cap=: [:

SAME=: Right=: ]

Catalogue=: From=: {
Head=: Take=: {.
Tail=: {:
Map=: Fetch=: {::

ItemAmend=: Amend=: }
Behead=: Drop=: }.
Curtail=: }:

Rank=: "
Do=: Numbers=: ".
DefaultFormat=: Format=: ":

Tie=: `
EvokeGerund=: `:

Atop=: @
Agenda=: @.
At=: @:

Bond=: Compose=: &
Under=: Dual=: &.
UNDER=: &.:
Appose=: &:

Roll=: Deal=: ?
NB.  The following names do not follow the conventions
NB.  above but were used in the previous Primitives script
RollFixed=: DealFixed=: ?.

Alphabet=: a.
Ace=: a:
AnagramIndex=: Anagram=: A.
Boolean=: Basic=: b.
Cycle=: Direct=: Permute=: C.
Derivative=: d.
DERIVATIVE=: D.
SecantSlope=: D:
RazeIn=: MemberIn=: In=: e.
MemberOfInterval=: E.
Fix=: f.
Hypergeometric=: H.
Integers=: IndexOf=: i.
INTEGERS=: IndexOfLast=: i:
Indices =: I.
Imaginary=: Complex=: j.
LevelOf=: L.
LevelAt=: L:
NB.  Retain Circular because of earlier usage
PiTimes=: CircleFunction=: Circular=: o.
Roots=: Polynomial=: p.
PolyDeriv=: PolyIntegral=: p..
Primes=: p:
PrimeFactors=: PrimeExponents=: q:
Angle=: Polar=: r.
Symbol=: s:
Spread=: S:
AssignTaylor=: TaylorCoefficient=: t.
WeightedTaylor=: t:
TaylorApproximation=: T.
Unicode=: u:
ExtendedPrecision=: x:
